#!/usr/bin/python3.4
import csv
import matplotlib.pyplot as plt
import math
import numpy as np

################## Model ##############################################################################################

#####################################################################################################
#################  VISIBLE SPECTRUM  ################################################################
#####################################################################################################

W1 = []
for i in range(171): #171
	xx1 = 250 + 5 *i
	W1.append(xx1)
I1 = [3.08E-05, 3.07E-05, 4.89E-05, 6.36E-05, 8.09E-05, 1.01E-04, 1.21E-04, 1.54E-04, 1.91E-04, 2.33E-04,
2.73E-04, 3.36E-04, 4.06E-04, 4.62E-04, 5.24E-04, 6.19E-04, 7.13E-04, 8.04E-04, 8.98E-04, 1.03E-03, 1.17E-03, 1.29E-03,
1.42E-03, 1.60E-03, 1.78E-03, 1.95E-03, 2.13E-03, 2.34E-03, 2.57E-03, 2.85E-03, 3.00E-03, 3.25E-03, 3.52E-03, 3.78E-03,
4.03E-03, 4.32E-03, 4.62E-03, 4.93E-03, 5.22E-03, 5.56E-03, 5.92E-03, 6.26E-03, 6.59E-03, 6.97E-03, 7.33E-03, 7.73E-03, 
8.08E-03, 8.46E-03, 8.86E-03, 9.23E-03, 9.63E-03, 1.00E-02, 1.05E-02, 1.09E-02, 1.13E-02, 1.17E-02, 1.21E-02, 1.25E-02,
1.29E-02, 1.33E-02, 1.38E-02, 1.42E-02, 1.46E-02, 1.50E-02, 1.54E-02, 1.58E-02, 1.62E-02, 1.66E-02, 1.70E-02, 1.74E-02, 
1.78E-02, 1.82E-02, 1.86E-02, 1.89E-02, 1.93E-02, 1.96E-02, 2.00E-02, 2.03E-02, 2.07E-02, 2.10E-02, 2.14E-02, 2.17E-02,
2.20E-02, 2.23E-02, 2.26E-02, 2.29E-02, 2.32E-02, 2.35E-02, 2.38E-02, 2.41E-02, 2.43E-02, 2.46E-02, 2.48E-02, 2.50E-02, 
2.53E-02, 2.53E-02, 2.54E-02, 2.56E-02, 2.58E-02, 2.60E-02, 2.62E-02, 2.64E-02, 2.66E-02, 2.68E-02, 2.69E-02, 2.70E-02,
2.71E-02, 2.73E-02, 2.74E-02, 2.75E-02, 2.76E-02, 2.78E-02, 2.79E-02, 2.80E-02, 2.81E-02, 2.82E-02, 2.82E-02, 2.83E-02, 
2.84E-02, 2.85E-02, 2.85E-02, 2.85E-02, 2.86E-02, 2.86E-02, 2.87E-02, 2.86E-02, 2.86E-02, 2.87E-02, 2.87E-02, 2.87E-02, 
2.87E-02, 2.86E-02, 2.86E-02, 2.86E-02, 2.86E-02, 2.87E-02, 2.85E-02, 2.85E-02, 2.85E-02, 2.84E-02, 2.83E-02, 2.82E-02, 
2.81E-02, 2.80E-02, 2.79E-02, 2.78E-02, 2.77E-02, 2.76E-02, 2.74E-02, 2.73E-02, 2.73E-02, 2.72E-02, 2.71E-02, 2.70E-02, 
2.68E-02, 2.67E-02, 2.66E-02, 2.64E-02, 2.63E-02, 2.62E-02, 2.60E-02, 2.59E-02, 2.57E-02, 2.56E-02, 2.55E-02, 2.54E-02,
2.53E-02, 2.51E-02, 2.50E-02, 2.49E-02, 2.47E-02,]

# Model Range for measurements
model_L = 3
model_R = 60
x_model = W1[model_L:model_R]
y_model = I1[model_L:model_R]

##################  Measured ##############################################################################################
####### READ DATA FILE SECTION #########################################
file_directory = '/home/jb0183/Measurements/Calibration/'
file_name = 'LAMP-Heraeus-400nm-300BLZ1_1'
full_directory = file_directory + file_name + '.txt'
file1 = open(full_directory,'r')
#read all the lines
all_lines = []
with file1 as f:
    for line in f:
        inner_list = [elt.strip() for elt in line.split(',')]
        all_lines.append(inner_list)      
#delete empty space in the first line (it must be done - in other case an error occurs)
del all_lines[0][-1]
#delete the first element in every list (like ,,wavelength'' ,,pixel''  etc.)
loops = len(all_lines)
for i in range(loops):
	del all_lines[i][0] 
#convert list of strings to list of floats
all_lines = [[float(float(j)) for j in i] for i in all_lines]
#CLOSE TXT FILE !
file1.close()

# Measured Range - to cut off ,,dead area''
Measured_L = 30
Measured_R = 980

x_Measured = all_lines[1][Measured_L:Measured_R]
y_Measured = all_lines[3][Measured_L:Measured_R]

# THE POINT (X axis) where two ranges meet (UV and visible)
# used for normalization
POINT = 330 #for a wavelength = 350 nm
#measured value  in a POINT 
P_Measured = all_lines[3][POINT]
#model value 
P_model = I1[20]
#ratio in a Point
P_ratio = P_model/P_Measured
# normalized values of y_
y_Measured_norm = [x * (P_ratio) for x in y_Measured]

############## trend line for model ###############################
#coefficients for polynomial, 4th degree
coe_model = np.polyfit(x_model,y_model,6)

#create new y values for model according to coefficients
loops = len(x_Measured)
y_model_trend = []
for i in range(loops):
	y_fit_model = coe_model[0]*math.pow(x_Measured[i],6) + coe_model[1]*math.pow(x_Measured[i],5) + coe_model[2]*math.pow(x_Measured[i],4) + coe_model[3]*math.pow(x_Measured[i],3) + coe_model[4]*math.pow(x_Measured[i],2) + coe_model[5]*x_Measured[i] + coe_model[6]
	y_model_trend.append(y_fit_model)

############## trend line for measurements ###############################
coe_Real = np.polyfit(x_Measured,y_Measured_norm,6)

#create new y values for measured values according to coefficients
loops = len(x_Measured)
y_Measured_norm_trend = []
for i in range(loops):
	y_fit_Measured = coe_Real[0]*math.pow(x_Measured[i],6) + coe_Real[1]*math.pow(x_Measured[i],5) + coe_Real[2]*math.pow(x_Measured[i],4) + coe_Real[3]*math.pow(x_Measured[i],3) + coe_Real[4]*math.pow(x_Measured[i],2) + coe_Real[5]*x_Measured[i] + coe_Real[6]
	y_Measured_norm_trend.append(y_fit_Measured)

############## correction factor ###############################

cor_fac = np.array(y_model_trend) / np.array(y_Measured_norm_trend)

data1 = open('Correction_factor_allinone.csv','w') 
csvwriter1 = csv.writer(data1) 
csvwriter1.writerow(x_Measured)
csvwriter1.writerow(cor_fac)

############## final list of correction values for y measured ###############################

y_Measured_cor = cor_fac * np.array(y_Measured_norm)

######### CHARTS ############################################
# Model line - actual and trend line
fig1 = plt.figure(1)
plot1 = fig1.add_subplot(4,2,2) 
plot1.plot(x_model,y_model)
plot2 = fig1.add_subplot(4,2,2)  
plot2.plot(x_Measured,y_Measured_cor)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')
plot3= fig1.add_subplot(4,2,4) 
plot3.plot(x_Measured,y_model_trend)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')

# Measured line - actual and trend line
plot4 = fig1.add_subplot(4,2,6) 
plot4.plot(x_Measured,y_Measured_norm)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')
plot5 = fig1.add_subplot(4,2,8)  
plot5.plot(x_Measured,y_Measured_norm_trend)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')

############################################################################
##################  UV  ##############################################################################################
##############################################################################
W2 = []
for i in range(19): 
	xx2 = 260 + 5 *i
	W2.append(xx2)
I2 = [9.773E-04, 8.949E-04, 8.206E-04, 7.528E-04, 6.912E-04, 6.392E-04, 5.911E-04, 5.493E-04, 5.114E-04, 4.745E-04, 4.446E-04,
4.142E-04, 3.821E-04, 3.559E-04, 3.342E-04, 3.115E-04, 2.911E-04, 2.759E-04, 2.593E-04]

x_UV_model = W2
y_UV_model = I2

##################  Measured ##############################################################################################
####### READ DATA FILE SECTION #########################################
file_directory = '/home/jb0183/Measurements/Calibration/'
#file_name = input('filename: ')
file_name = 'UV-200um-400nm-300BLZ1_1'
full_directory = file_directory + file_name + '.txt'
file1 = open(full_directory,'r')
#read all the lines
all_lines = []
with file1 as f:
    for line in f:
        inner_list = [elt.strip() for elt in line.split(',')]
        all_lines.append(inner_list)  
#delete empty space in the first line (it must be done - in other case an error occurs)
del all_lines[0][-1]
#delete the first element in every list (like ,,wavelength'' ,,pixel''  etc.)
loops = len(all_lines)
for i in range(loops):
	del all_lines[i][0] 
#convert list of strings to list of floats
all_lines = [[float(float(j)) for j in i] for i in all_lines]
#CLOSE TXT FILE !
file1.close()

# Measured Range - the range between 260 and 350 (UV)
Measured_UV_L = 30
Measured_UV_R = POINT #meet piont

#normalizalion of the measured values - max is ,,1''
x_UV_Measured = all_lines[1][Measured_UV_L:Measured_UV_R]
y_UV_Measured= all_lines[3][Measured_UV_L:Measured_UV_R]

#measured value  in a POINT 
P_UV_Measured = all_lines[3][POINT]
#model value
P_UV_model = I2[18]
#ratio in a Point
P_UV_ratio = P_UV_model/P_UV_Measured

y_UV_Measured_norm = [x * (P_UV_ratio) for x in y_UV_Measured]

############## trend line for model ###############################
#coefficients for polynomial, 4th degree
coe_model_UV = np.polyfit(x_UV_model,y_UV_model,6)

#create new y values for model according to coefficients
loops = len(x_UV_Measured)
y_UV_model_trend = []
for i in range(loops):
	y_UV_fit_model = coe_model_UV[0]*math.pow(x_UV_Measured[i],6) + coe_model_UV[1]*math.pow(x_UV_Measured[i],5) + coe_model_UV[2]*math.pow(x_UV_Measured[i],4) + coe_model_UV[3]*math.pow(x_UV_Measured[i],3) + coe_model_UV[4]*math.pow(x_UV_Measured[i],2) + coe_model_UV[5]*x_UV_Measured[i] + coe_model_UV[6]
	y_UV_model_trend.append(y_UV_fit_model)

############## trend line for measurements ###############################
coe_Real_UV = np.polyfit(x_UV_Measured,y_UV_Measured_norm,6)

#create new y values for measured values according to coefficients
loops = len(x_UV_Measured)
y_UV_Measured_norm_trend = []
for i in range(loops):
	y_UV_fit_Measured = coe_Real_UV[0]*math.pow(x_UV_Measured[i],6) + coe_Real_UV[1]*math.pow(x_UV_Measured[i],5) + coe_Real_UV[2]*math.pow(x_UV_Measured[i],4) + coe_Real_UV[3]*math.pow(x_UV_Measured[i],3) + coe_Real_UV[4]*math.pow(x_UV_Measured[i],2) + coe_Real_UV[5]*x_UV_Measured[i] + coe_Real_UV[6]
	y_UV_Measured_norm_trend.append(y_UV_fit_Measured)

############## correction factor ###############################

cor_fac_UV = np.array(y_UV_model_trend) / np.array(y_UV_Measured_norm_trend)

############## final list of corrected values for y measured ###############################

y_UV_Measured_cor = cor_fac_UV * np.array(y_UV_Measured_norm)
csvwriter1.writerow(cor_fac_UV)

######### CHARTS ############################################

# Model line - actual and trend line
plot6 = fig1.add_subplot(4,2,1)  
plot6.plot(x_UV_model,y_UV_model)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')
plot7 = fig1.add_subplot(4,2,1)  
plot7.plot(x_UV_Measured,y_UV_Measured_cor)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')

plot8 = fig1.add_subplot(4,2,3)  
plot8.plot(x_UV_Measured,y_UV_model_trend)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')

# Measured line - actual and trend line
plot1 = fig1.add_subplot(4,2,5)  
plot1.plot(x_UV_Measured,y_UV_Measured_norm)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')

plot10 = fig1.add_subplot(4,2,7)  
plot10.plot(x_UV_Measured,y_UV_Measured_norm_trend)
plt.xlabel('wavelength (nm)')
plt.ylabel('Intensity')

plt.show()

for j in range((len(cor_fac_UV))):
	cor_fac[j] = cor_fac_UV[j]

csvwriter1.writerow(cor_fac)
#CLOSE CSV FILE
data1.close()

